function assignVisitor(node) {
   for(var i in node.statements) {
      var loc = node.loc
      var lhs = node.statements[i].type
      var rhs = node.statements[i].assign

      if( rhs && lhs ) {

         if( lhs.unsigned ) {
            if(parseInt(rhs[0].value) > 0) { 
               print( "ASSIGN: negative to unsigned at:"+loc+"\n" )
            }
            else if(rhs[0].type && !rhs[0].type.unsigned) {
               print( "ASSIGN: signed to unsigned at:"+loc+"\n" )
            }
         }
         else if(rhs[0].type) {// lhs is signed
            if( rhs[0].type.unsigned ) {
               print( "ASSIGN: unsigned to signed at:"+loc+"\n" );
            }
         }
      }
   }
}

function process_function(decl,body) {
   iter(assignVisitor, body)
}

function process_type(decl,body) {
   print("PROCESS TYPE")
}

function input_end() {
}

function isArray(obj) {
   if( obj.constructor.toString().indexOf("Array") == -1 )
      return false;
   else
      return true;
}

function isObject(obj) {
   if( obj.constructor.toString().indexOf("Object") == -1 )
      return false;
   else
      return true;
}

function isString(obj) {
   if( obj.constructor.toString().indexOf("String") == -1 )
      return false;
   else
      return true;
}

